commit d0d786ddd594521d075cdc67a8906ef21ae0936f
Author: freddy77 <freddy77>
Date:   Wed Jul 30 21:25:53 2008 +0000

    additional cleanup and notes

diff --git a/ChangeLog b/ChangeLog
index 4ee69bb..f567614 100644
--- a/ChangeLog
+++ b/ChangeLog
@@ -1,3 +1,6 @@
+Wed Jul 30 23:25:26 CET 2008    Frediano Ziglio <freddy77_A_gmail_D_com>
+	* src/tds/challenge.c: additional cleanup and notes
+
 Wed Jul 30 16:36:52 CET 2008    Frediano Ziglio <freddy77_A_gmail_D_com>
 	* src/tds/challenge.c:
 	- merged patch #2031829 about NTLMv2, still some FIXME/TODO
@@ -495,4 +498,4 @@ Wed Jan  9 19:54:43 EST 2008	JK Lowden <jklowden@freetds.org>
 	* ChangeLog  truncated because of release
 	* ChangeLog-0.82 added because of release
 	
-$Id: ChangeLog,v 1.2571 2008/07/30 14:38:07 freddy77 Exp $
+$Id: ChangeLog,v 1.2572 2008/07/30 21:25:53 freddy77 Exp $
diff --git a/src/tds/challenge.c b/src/tds/challenge.c
index bfd6e83..7f93978 100644
--- a/src/tds/challenge.c
+++ b/src/tds/challenge.c
@@ -45,7 +45,7 @@
 #include <dmalloc.h>
 #endif
 
-TDS_RCSID(var, "$Id: challenge.c,v 1.31 2008/07/30 14:38:09 freddy77 Exp $");
+TDS_RCSID(var, "$Id: challenge.c,v 1.32 2008/07/30 21:25:53 freddy77 Exp $");
 
 /**
  * \ingroup libtds
@@ -75,10 +75,7 @@ typedef struct
 	TDS_TINYINT     max_response_type;
 	TDS_SMALLINT    reserved1;
 	TDS_UINT        reserved2;
-	union {
-		TDS_UINT8       l;
-		unsigned char   s[8];
-	} timestamp;
+	TDS_UINT8       timestamp;
 	TDS_UCHAR       challenge[8];
 	TDS_UINT        unknown;
 	/* target info block - variable length */
@@ -581,36 +578,6 @@ unix_to_nt_time(TDS_UINT8 * nt, time_t t)
 	*nt = t2;
 }
 
-/* TODO I don't like this stuf here -- freddy77 */
-#ifdef WORDS_BIGENDIAN
-static TDS_UINT
-swap_32(TDS_UINT val)
-{
-	return (((((TDS_UINT) val) & 0xff000000) >> 24) | ((((TDS_UINT) val) & 0x00ff0000) >> 8) |
-		((((TDS_UINT) val) & 0x0000ff00) << 8) | ((((TDS_UINT) val) & 0x000000ff) << 24));
-}
-#endif
-
-static TDS_UINT8
-to_le(TDS_UINT8 val)
-{
-#ifndef WORDS_BIGENDIAN
-	return val;
-#else
-	union
-	{
-		TDS_UINT8 ll;
-		TDS_UINT l[2];
-	} w, r;
-
-	w.ll = val;
-	r.l[0] = swap_32(w.l[1]);
-	r.l[1] = swap_32(w.l[0]);
-	return r.ll;
-#endif
-}
-
-
 static void
 fill_names_blob_prefix(names_blob_prefix_t * prefix)
 {
@@ -623,7 +590,10 @@ fill_names_blob_prefix(names_blob_prefix_t * prefix)
 	prefix->max_response_type = 0x01;
 	prefix->reserved1 = 0x0000;
 	prefix->reserved2 = 0x00000000;
-	prefix->timestamp.l = to_le(nttime);
+#ifdef WORDS_BIGENDIAN
+	tds_swap_bytes(&nttime, 8);
+#endif
+	prefix->timestamp = nttime;
 	generate_random_buffer(prefix->challenge, sizeof(prefix->challenge));
 
 	prefix->unknown = 0x00000000;
@@ -689,7 +659,12 @@ tds_ntlm_handle_next(TDSSOCKET * tds, struct tds_authentication * auth, size_t l
 		tds_get_n(tds, NULL, target_info_offset - where);
 		where = target_info_offset;
 
-		/* TODO why + 4 ?? -- freddy77 */
+		/*
+		 * the + 4 came from blob structure, after Target Info 4
+		 * additional reserved bytes must be present
+		 * Search "davenport port"
+		 * (currently http://davenport.sourceforge.net/ntlm.html)
+		 */
 		names_blob_len = sizeof(names_blob_prefix_t) + target_info_len + 4;
 
 		/* read Target Info */

